#!/software/bin/perl
#########
# Author:        gq1
# Maintainer:    $Author: ajb $
# Created:       18 January 2010
# Last Modified: $Date: 2011-08-10 10:05:48 +0100 (Wed, 10 Aug 2011) $
# Id:            $Id: fastq2bam.pl 13877 2011-08-10 09:05:48Z ajb $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/useful_modules/tags/release-38.0/scripts/fastq2bam.pl $
#

#########################
# This script generate bam file from the given fastq files
# id_run and position needed to get reference if rererence not given
##########################

use strict;
use warnings;
use lib qw(lib /software/solexa/lib/perl5);

use npg_common::sequence::BAM_Generation;

use Readonly; Readonly::Scalar our $VERSION => do { my ($r) = q$Revision: 13877 $ =~ /(\d+)/smx; $r; };

npg_common::sequence::BAM_Generation->new_with_options()->generate();

exit 0;

=head1 NAME

fastq2bam.pl

=head1 VERSION

$LastChangedRevision: 13877 $

=head1 USAGE

  fastq2bam.pl --id_run 4129 --position 4 --fastq_files /path/to/fastq/file1 -fastq_files 4219_4_2.fastq --bam_filename /tmp/4129_4
  
  If you want to add second base call to the bam file, you must give extra options:
  --second_call_qseq_dir /nfs/sf11/IL6/outgoing/100209_IL6_4129/Data/Intensities/Bustard1.6.0a14_17-02-2010_RTA/SecondCall --read_number_1 1 --read_number_2 2

  For read_number, --read_number_1 1 for single read run. --read_number_1 1 --read_number_2 3 for multiplex paired run
  
  If you want to add index sequence and quality to bam file, --index_fastq_file should given
  
  If bam file is for human or nonhuman, the human_split should be given: --human_split ( human or nonhuman )
  
  If for plex bam bam file, --tag_index should be given
  
  The reference is not necessary to be given from command line, it will be figured out using id_run, position, tag_index and human_split type. If it can't be figured out, bam file will be created withour alignment.
  
  Given --no-alignment option, bam file will be created without alignment.
  
  --archive_path can be given to be more spicific runfolder

=head1 CONFIGURATION

=head1 SYNOPSIS

=head1 DESCRIPTION

=head1 SUBROUTINES/METHODS

=head1 DIAGNOSTICS

=head1 CONFIGURATION AND ENVIRONMENT

=head1 DEPENDENCIES

=over

=item strict

=item warnings

=item npg_common::sequence::BAM_Generation

=back

=head1 INCOMPATIBILITIES

=head1 BUGS AND LIMITATIONS

=head1 AUTHOR

Guoying Qi E<lt>gq1@sanger.ac.ukE<gt>

=head1 LICENSE AND COPYRIGHT

Copyright (C) 2009 GRL, by Guoying Qi

This file is part of NPG.

NPG is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

=cut

