#########
# Author:        gq1
# Maintainer:    $Author: ajb $
# Created:       2011-07-01
# Last Modified: $Date: 2011-08-10 10:05:48 +0100 (Wed, 10 Aug 2011) $
# Id:            $Id: 10-irods-BamMetaUpdater.t 13877 2011-08-10 09:05:48Z ajb $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/useful_modules/tags/release-38.0/t/10-irods-BamMetaUpdater.t $
#

use strict;
use warnings;
use Carp;
use English qw{-no_match_vars};
use Test::More tests => 7;
use Test::Exception;
use JSON;

use_ok('npg_common::irods::BamMetaUpdater');

{
  my $bam = npg_common::irods::BamMetaUpdater->new(verbose => 1,
                                                   id_run => 6345,
                                                   lane => 6,
                                                   tag_index => 6
                                                   );
  
  my $result = [$bam->parsing_bam_filename("/seq/6345/6345_5.bam")];
  is_deeply( $result, [6345, 5, undef, undef], 'id_run, lane' );

  $result = [$bam->parsing_bam_filename("/seq/6345/6345_5_phix.bam")];
  is_deeply( $result, [6345, 5, undef, 'phix'], 'id_run, lane, phix' );

  $result = [$bam->parsing_bam_filename("/seq/6345/6345_5_phix#6.bam")];
  is_deeply( $result, [6345, 5, 6, 'phix'], 'id_run, lane, phix, plex' );

  $result = [$bam->parsing_bam_filename("/seq/6345/6345_5_nonhuman#6.bam")];
  is_deeply( $result, [6345, 5, 6, 'nonhuman'], 'id_run, lane, nohuman plex' );
  
  $result = [$bam->parsing_bam_filename("/seq/6345/6345_5#6.bam")];
  is_deeply( $result, [6345, 5, 6, undef], 'id_run, lane, plex' );
  
  $result = [$bam->parsing_bam_filename("/seq/6345/6345_5#6_pf0.bam")];
  is_deeply( $result, [6345, 5, 6, undef], 'id_run, lane, plex pf0' );
  
  #print to_json( $bam->get_current_irods_meta("/seq/6345/6345_5_human#5.bam") ), "\n";
  
  #$bam->process();
  
  #my $npg_information = $bam->get_warehouse_npg_information(6345, 6, 1);

  #$npg_information = $bam->get_warehouse_npg_information(6000, 1);
  
  #$npg_information = $bam->get_warehouse_npg_information(6345, 6, 0);

}

1;
__END__
