#########
# Author:        gq1
# Maintainer:    $Author: ajb $
# Created:       2009-06-21
# Last Modified: $Date: 2011-08-10 10:05:48 +0100 (Wed, 10 Aug 2011) $
# Id:            $Id: 10-sequence-BAM_MarkDuplicate.t 13877 2011-08-10 09:05:48Z ajb $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/useful_modules/tags/release-38.0/t/10-sequence-BAM_MarkDuplicate.t $
#

use strict;
use warnings;
use Carp;
use English qw{-no_match_vars};
use Test::More tests => 6;
use Test::Exception;
use Cwd;

use lib q{t};
use t::util;

my $util = t::util->new();

use_ok('npg_common::sequence::BAM_MarkDuplicate');

{
  my $picard_jar_file = 't/bin/aligners/picard/current/MarkDuplicates.jar';

  my $bam = npg_common::sequence::BAM_MarkDuplicate->new(
               {
                 input_bam     => 'input.bam',
                 output_bam    => 'output.bam',
                 metrics_json  => 'metrics.json',
                 jar_file      => 't/bin/aligners/picard/current/MarkDuplicates.jar',
               });
              
  isa_ok($bam, 'npg_common::sequence::BAM_MarkDuplicate', 'object test');
  
  lives_ok {$bam->temp_dir} 'temp dir generated';
  
  lives_ok {$bam->metrics_file()} 'temp metrics file';
  
  lives_ok {$bam->result} 'result object';

  $bam->metrics_file('metrics.txt');

  my $temp_dir = $util->temp_directory();
  $bam->temp_dir($temp_dir);

  my $abs_jar_file = getcwd().q{/t/bin/aligners/picard/picard-tools-1.31/MarkDuplicates.jar};

  is($bam->mark_duplicate_cmd(), qq{/software/bin/java -Xmx3000m -jar $abs_jar_file INPUT=input.bam OUTPUT=output.bam METRICS_FILE=metrics.txt TMP_DIR=$temp_dir MAX_FILE_HANDLES_FOR_READ_ENDS_MAP='900' VALIDATION_STRINGENCY='SILENT' REMOVE_DUPLICATES='false' ASSUME_SORTED='true' CREATE_INDEX='TRUE' VERBOSITY='ERROR' READ_NAME_REGEX='[a-zA-Z0-9_]+:[0-9]:([0-9]+):([0-9]+):([0-9]+).*' CREATE_MD5_FILE='TRUE'}, 'correct picard command');
}
1;
