use strict;
use warnings;
use Carp;
use English qw{-no_match_vars};
use Test::More tests => 7;
use Test::Exception;

BEGIN {
  use_ok(q{npg_common::pod_usage});
}
{
  my $oPodUsage;
  lives_ok { $oPodUsage = npg_common::pod_usage->new({file_name => q{lib/npg_common/pod_usage.pm}}); } q{object created ok with a file_name provided};
  isa_ok($oPodUsage, q{npg_common::pod_usage}, q{$oPodUsage});
  my $output = qq{SYNOPSIS\n};
  $output   .= qq{    Typically, you will just want to output the usage sections directly\n\n};
  $output   .=  q{      print npg_common::pod_usage->new()->usage_sections(); # runs on the current program file by default}.qq{\n};
  $output   .=  q{      print npg_common::pod_usage->new({file_name => $sFileName})->usage_sections();}.qq{\n\n};
  $output   .= qq{    although you can create an object and capture the usage_sections into a\n};
  $output   .= qq{    string variable\n\n};
  $output   .=  q{      my $oPodUsage = npg_common::pod_usage->new();}. qq{\n};
  $output   .=  q{      my $oPodUsage = npg_common::pod_usage->new({file_name => $sFileName});}.qq{\n\n};
  is($oPodUsage->usage_sections(), $output, q{output is correct});
}
{
  my $oPodUsage;
  lives_ok { $oPodUsage = npg_common::pod_usage->new(); } q{object created ok when a file_name is not provided};
  is($oPodUsage->file_name(), q{t/50-pod_usage.t}, q{file_name auto built as the test_file});
  is($oPodUsage->usage_sections(), q{}, q{output when file_name is test file is correct});
}
1;